#define MAX_REGISTERS 256

struct gen_register_file
{
	struct
	{
		bool used;
		bool wide;
	} reg[MAX_REGISTERS];
	int num_used;
	int max_used;
};

struct gen_stack
{
	int pointer;
	int max_pointer;
};

struct gen_class
{
	char * full_name;
	FILE * fp;
	gen_proc_t * p;
	struct gen_class * base;
};

enum gen_storage
{
	JVM_STORAGE_UNKNOWN,
	JVM_STORAGE_REGISTER,
	JVM_STORAGE_STATIC,
	JVM_STORAGE_FIELD
};


struct gen_proc_t
{
	int label_id;
	struct gen_register_file * rf;
	struct gen_stack * stack;
	struct gen_class * class;
};

struct gen_type_t
{
	int rec_id;
	struct gen_class * class;
};

struct gen_var_t
{
	enum gen_storage storage;
	int reg;
	char * full_name;
	char * desc;
};

struct gen_context_t
{
	gen_module_t * current_m;
};

struct gen_module_t
{
	struct gen_class * class;
	int rec_id;
};

struct gen_label_t
{
	int id;
};
